diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/realtime-simulator-impl.cc ns-3.40/src/core/model/realtime-simulator-impl.cc
--- ns-3.39/src/core/model/realtime-simulator-impl.cc	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/realtime-simulator-impl.cc	2023-09-27 13:30:37.630839000 -0700
@@ -704,7 +704,7 @@
     if (id.GetUid() == EventId::UID::DESTROY)
     {
         // destroy events.
-        for (DestroyEvents::iterator i = m_destroyEvents.begin(); i != m_destroyEvents.end(); i++)
+        for (auto i = m_destroyEvents.begin(); i != m_destroyEvents.end(); i++)
         {
             if (*i == id)
             {
@@ -754,8 +754,7 @@
             return true;
         }
         // destroy events.
-        for (DestroyEvents::const_iterator i = m_destroyEvents.begin(); i != m_destroyEvents.end();
-             i++)
+        for (auto i = m_destroyEvents.begin(); i != m_destroyEvents.end(); i++)
         {
             if (*i == id)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/simulator.h ns-3.40/src/core/model/simulator.h
--- ns-3.39/src/core/model/simulator.h	2023-07-05 14:23:47.765427000 -0700
+++ ns-3.40/src/core/model/simulator.h	2023-09-27 13:30:37.630839000 -0700
@@ -228,12 +228,10 @@
      * @param [in] args Arguments to pass to MakeEvent.
      * @returns The id for the scheduled event.
      */
-    template <
-        typename FUNC,
-        typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value, int>::type = 0,
-        typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,
-                                int>::type = 0,
-        typename... Ts>
+    template <typename FUNC,
+              std::enable_if_t<!std::is_convertible_v<FUNC, Ptr<EventImpl>>, int> = 0,
+              std::enable_if_t<!std::is_function_v<std::remove_pointer_t<FUNC>>, int> = 0,
+              typename... Ts>
     static EventId Schedule(const Time& delay, FUNC f, Ts&&... args);
 
     /**
@@ -276,12 +274,10 @@
      * @param [in] f The function to invoke.
      * @param [in] args Arguments to pass to MakeEvent.
      */
-    template <
-        typename FUNC,
-        typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value, int>::type = 0,
-        typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,
-                                int>::type = 0,
-        typename... Ts>
+    template <typename FUNC,
+              std::enable_if_t<!std::is_convertible_v<FUNC, Ptr<EventImpl>>, int> = 0,
+              std::enable_if_t<!std::is_function_v<std::remove_pointer_t<FUNC>>, int> = 0,
+              typename... Ts>
     static void ScheduleWithContext(uint32_t context, const Time& delay, FUNC f, Ts&&... args);
 
     /**
@@ -321,12 +317,10 @@
      * @param [in] args Arguments to pass to the invoked function.
      * @return The EventId of the scheduled event.
      */
-    template <
-        typename FUNC,
-        typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value, int>::type = 0,
-        typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,
-                                int>::type = 0,
-        typename... Ts>
+    template <typename FUNC,
+              std::enable_if_t<!std::is_convertible_v<FUNC, Ptr<EventImpl>>, int> = 0,
+              std::enable_if_t<!std::is_function_v<std::remove_pointer_t<FUNC>>, int> = 0,
+              typename... Ts>
     static EventId ScheduleNow(FUNC f, Ts&&... args);
 
     /**
@@ -365,12 +359,10 @@
      * @param [in] args Arguments to pass to MakeEvent.
      * @return The EventId of the scheduled event.
      */
-    template <
-        typename FUNC,
-        typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value, int>::type = 0,
-        typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,
-                                int>::type = 0,
-        typename... Ts>
+    template <typename FUNC,
+              std::enable_if_t<!std::is_convertible_v<FUNC, Ptr<EventImpl>>, int> = 0,
+              std::enable_if_t<!std::is_function_v<std::remove_pointer_t<FUNC>>, int> = 0,
+              typename... Ts>
     static EventId ScheduleDestroy(FUNC f, Ts&&... args);
 
     /**
@@ -558,12 +550,10 @@
 // it treats the in-class declaration as different from the
 // out of class definition, so makes two entries in the member list.  Ugh
 
-template <
-    typename FUNC,
-    typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value, int>::type,
-    typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,
-                            int>::type,
-    typename... Ts>
+template <typename FUNC,
+          std::enable_if_t<!std::is_convertible_v<FUNC, Ptr<EventImpl>>, int>,
+          std::enable_if_t<!std::is_function_v<std::remove_pointer_t<FUNC>>, int>,
+          typename... Ts>
 EventId
 Simulator::Schedule(const Time& delay, FUNC f, Ts&&... args)
 {
@@ -577,12 +567,10 @@
     return DoSchedule(delay, MakeEvent(f, std::forward<Ts>(args)...));
 }
 
-template <
-    typename FUNC,
-    typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value, int>::type,
-    typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,
-                            int>::type,
-    typename... Ts>
+template <typename FUNC,
+          std::enable_if_t<!std::is_convertible_v<FUNC, Ptr<EventImpl>>, int>,
+          std::enable_if_t<!std::is_function_v<std::remove_pointer_t<FUNC>>, int>,
+          typename... Ts>
 void
 Simulator::ScheduleWithContext(uint32_t context, const Time& delay, FUNC f, Ts&&... args)
 {
@@ -596,12 +584,10 @@
     return ScheduleWithContext(context, delay, MakeEvent(f, std::forward<Ts>(args)...));
 }
 
-template <
-    typename FUNC,
-    typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value, int>::type,
-    typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,
-                            int>::type,
-    typename... Ts>
+template <typename FUNC,
+          std::enable_if_t<!std::is_convertible_v<FUNC, Ptr<EventImpl>>, int>,
+          std::enable_if_t<!std::is_function_v<std::remove_pointer_t<FUNC>>, int>,
+          typename... Ts>
 EventId
 Simulator::ScheduleNow(FUNC f, Ts&&... args)
 {
@@ -615,12 +601,10 @@
     return DoScheduleNow(MakeEvent(f, std::forward<Ts>(args)...));
 }
 
-template <
-    typename FUNC,
-    typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value, int>::type,
-    typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,
-                            int>::type,
-    typename... Ts>
+template <typename FUNC,
+          std::enable_if_t<!std::is_convertible_v<FUNC, Ptr<EventImpl>>, int>,
+          std::enable_if_t<!std::is_function_v<std::remove_pointer_t<FUNC>>, int>,
+          typename... Ts>
 EventId
 Simulator::ScheduleDestroy(FUNC f, Ts&&... args)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/system-path.cc ns-3.40/src/core/model/system-path.cc
--- ns-3.39/src/core/model/system-path.cc	2023-07-05 14:23:47.765427000 -0700
+++ ns-3.40/src/core/model/system-path.cc	2023-09-27 13:30:37.630839000 -0700
@@ -141,7 +141,7 @@
 {
     NS_LOG_FUNCTION(path);
     std::list<std::string> elements = Split(path);
-    std::list<std::string>::const_iterator last = elements.end();
+    auto last = elements.end();
     last--;
     return Join(elements.begin(), last);
 }
@@ -268,7 +268,7 @@
 {
     NS_LOG_FUNCTION(*begin << *end);
     std::string retval = "";
-    for (std::list<std::string>::const_iterator i = begin; i != end; i++)
+    for (auto i = begin; i != end; i++)
     {
         if ((*i).empty())
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/test.cc ns-3.40/src/core/model/test.cc
--- ns-3.39/src/core/model/test.cc	2023-07-05 14:23:47.765427000 -0700
+++ ns-3.40/src/core/model/test.cc	2023-09-27 13:30:37.630839000 -0700
@@ -290,7 +290,7 @@
     NS_ASSERT(m_runner == nullptr);
     m_parent = nullptr;
     delete m_result;
-    for (std::vector<TestCase*>::const_iterator i = m_children.begin(); i != m_children.end(); ++i)
+    for (auto i = m_children.begin(); i != m_children.end(); ++i)
     {
         delete *i;
     }
@@ -353,7 +353,7 @@
     m_runner = runner;
     DoSetup();
     m_result->clock.Start();
-    for (std::vector<TestCase*>::const_iterator i = m_children.begin(); i != m_children.end(); ++i)
+    for (auto i = m_children.begin(); i != m_children.end(); ++i)
     {
         TestCase* test = *i;
         test->Run(runner);
@@ -571,7 +571,7 @@
     //
 
     std::list<std::string> files = SystemPath::ReadFiles(path);
-    for (std::list<std::string>::const_iterator i = files.begin(); i != files.end(); ++i)
+    for (auto i = files.begin(); i != files.end(); ++i)
     {
         if (*i == "VERSION")
         {
@@ -629,7 +629,7 @@
     {
         char character = xml[i];
 
-        specials_map::const_iterator it = specials.find(character);
+        auto it = specials.find(character);
 
         if (it == specials.end())
         {
@@ -802,9 +802,9 @@
     label[TestSuite::EXAMPLE] = "example      ";
     label[TestSuite::PERFORMANCE] = "performance  ";
 
-    for (std::list<TestCase*>::const_iterator i = begin; i != end; ++i)
+    for (auto i = begin; i != end; ++i)
     {
-        TestSuite* test = dynamic_cast<TestSuite*>(*i);
+        auto test = dynamic_cast<TestSuite*>(*i);
         NS_ASSERT(test != nullptr);
         if (printTestType)
         {
@@ -852,8 +852,7 @@
         }
 
         // Remove any test cases that should be skipped.
-        std::vector<TestCase*>::iterator j;
-        for (j = test->m_children.begin(); j != test->m_children.end();)
+        for (auto j = test->m_children.begin(); j != test->m_children.end();)
         {
             TestCase* testCase = *j;
 
@@ -1090,7 +1089,7 @@
         return 1;
     }
 
-    for (std::list<TestCase*>::const_iterator i = tests.begin(); i != tests.end(); ++i)
+    for (auto i = tests.begin(); i != tests.end(); ++i)
     {
         TestCase* test = *i;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/time.cc ns-3.40/src/core/model/time.cc
--- ns-3.39/src/core/model/time.cc	2023-07-05 14:23:47.765427000 -0700
+++ ns-3.40/src/core/model/time.cc	2023-09-27 13:30:37.630839000 -0700
@@ -255,7 +255,7 @@
             info->isValid = false;
             continue;
         }
-        int64_t factor = static_cast<int64_t>(std::pow(10, std::fabs(shift)) * quotient);
+        auto factor = static_cast<int64_t>(std::pow(10, std::fabs(shift)) * quotient);
         double realFactor = std::pow(10, (double)shift) * static_cast<double>(UNIT_COEFF[i]) /
                             UNIT_COEFF[(int)unit];
         NS_LOG_DEBUG("SetResolution factor " << factor << " real factor " << realFactor);
@@ -333,9 +333,7 @@
     // since earlier test was outside and might be stale.
     if (g_markingTimes)
     {
-        std::pair<MarkedTimes::iterator, bool> ret;
-
-        ret = g_markingTimes->insert(time);
+        auto ret = g_markingTimes->insert(time);
         NS_LOG_LOGIC("\t[" << g_markingTimes->size() << "] recording " << time);
 
         if (!ret.second)
@@ -385,7 +383,7 @@
                   "No MarkedTimes registry. "
                   "Time::SetResolution () called more than once?");
 
-    for (MarkedTimes::iterator it = g_markingTimes->begin(); it != g_markingTimes->end(); it++)
+    for (auto it = g_markingTimes->begin(); it != g_markingTimes->end(); it++)
     {
         Time* const tp = *it;
         if (!(tp->m_data == std::numeric_limits<int64_t>::min() ||
@@ -434,7 +432,7 @@
 
     if (unit == Time::AUTO)
     {
-        long double value = static_cast<long double>(timeU.m_time.GetTimeStep());
+        auto value = static_cast<long double>(timeU.m_time.GetTimeStep());
         // convert to finest scale (fs)
         value *= Scale(Time::GetResolution());
         // find the best unit
@@ -547,7 +545,7 @@
         bool Check(const AttributeValue& value) const override
         {
             NS_LOG_FUNCTION(&value);
-            const TimeValue* v = dynamic_cast<const TimeValue*>(&value);
+            const auto v = dynamic_cast<const TimeValue*>(&value);
             if (v == nullptr)
             {
                 return false;
@@ -585,8 +583,8 @@
         bool Copy(const AttributeValue& source, AttributeValue& destination) const override
         {
             NS_LOG_FUNCTION(&source << &destination);
-            const TimeValue* src = dynamic_cast<const TimeValue*>(&source);
-            TimeValue* dst = dynamic_cast<TimeValue*>(&destination);
+            const auto src = dynamic_cast<const TimeValue*>(&source);
+            auto dst = dynamic_cast<TimeValue*>(&destination);
             if (src == nullptr || dst == nullptr)
             {
                 return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/timer-impl.h ns-3.40/src/core/model/timer-impl.h
--- ns-3.39/src/core/model/timer-impl.h	2023-07-05 14:23:47.765427000 -0700
+++ ns-3.40/src/core/model/timer-impl.h	2023-09-27 13:30:37.630839000 -0700
@@ -1085,7 +1085,7 @@
 TimerImpl::SetArgs(T1 a1)
 {
     typedef TimerImplOne<typename TimerTraits<T1>::ParameterType> TimerImplBase;
-    TimerImplBase* impl = dynamic_cast<TimerImplBase*>(this);
+    auto impl = dynamic_cast<TimerImplBase*>(this);
     if (impl == nullptr)
     {
         NS_FATAL_ERROR("You tried to set Timer arguments incompatible with its function.");
@@ -1101,7 +1101,7 @@
     typedef TimerImplTwo<typename TimerTraits<T1>::ParameterType,
                          typename TimerTraits<T2>::ParameterType>
         TimerImplBase;
-    TimerImplBase* impl = dynamic_cast<TimerImplBase*>(this);
+    auto impl = dynamic_cast<TimerImplBase*>(this);
     if (impl == nullptr)
     {
         NS_FATAL_ERROR("You tried to set Timer arguments incompatible with its function.");
@@ -1118,7 +1118,7 @@
                            typename TimerTraits<T2>::ParameterType,
                            typename TimerTraits<T3>::ParameterType>
         TimerImplBase;
-    TimerImplBase* impl = dynamic_cast<TimerImplBase*>(this);
+    auto impl = dynamic_cast<TimerImplBase*>(this);
     if (impl == nullptr)
     {
         NS_FATAL_ERROR("You tried to set Timer arguments incompatible with its function.");
@@ -1136,7 +1136,7 @@
                           typename TimerTraits<T3>::ParameterType,
                           typename TimerTraits<T4>::ParameterType>
         TimerImplBase;
-    TimerImplBase* impl = dynamic_cast<TimerImplBase*>(this);
+    auto impl = dynamic_cast<TimerImplBase*>(this);
     if (impl == nullptr)
     {
         NS_FATAL_ERROR("You tried to set Timer arguments incompatible with its function.");
@@ -1155,7 +1155,7 @@
                           typename TimerTraits<T4>::ParameterType,
                           typename TimerTraits<T5>::ParameterType>
         TimerImplBase;
-    TimerImplBase* impl = dynamic_cast<TimerImplBase*>(this);
+    auto impl = dynamic_cast<TimerImplBase*>(this);
     if (impl == nullptr)
     {
         NS_FATAL_ERROR("You tried to set Timer arguments incompatible with its function.");
@@ -1175,7 +1175,7 @@
                          typename TimerTraits<T5>::ParameterType,
                          typename TimerTraits<T6>::ParameterType>
         TimerImplBase;
-    TimerImplBase* impl = dynamic_cast<TimerImplBase*>(this);
+    auto impl = dynamic_cast<TimerImplBase*>(this);
     if (impl == 0)
     {
         NS_FATAL_ERROR("You tried to set Timer arguments incompatible with its function.");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/traced-callback.h ns-3.40/src/core/model/traced-callback.h
--- ns-3.39/src/core/model/traced-callback.h	2023-07-05 14:23:47.765427000 -0700
+++ ns-3.40/src/core/model/traced-callback.h	2023-09-27 13:30:37.634839000 -0700
@@ -162,8 +162,7 @@
 void
 TracedCallback<Ts...>::DisconnectWithoutContext(const CallbackBase& callback)
 {
-    for (typename CallbackList::iterator i = m_callbackList.begin(); i != m_callbackList.end();
-         /* empty */)
+    for (auto i = m_callbackList.begin(); i != m_callbackList.end(); /* empty */)
     {
         if ((*i).IsEqual(callback))
         {
@@ -193,9 +192,7 @@
 void
 TracedCallback<Ts...>::operator()(Ts... args) const
 {
-    for (typename CallbackList::const_iterator i = m_callbackList.begin();
-         i != m_callbackList.end();
-         i++)
+    for (auto i = m_callbackList.begin(); i != m_callbackList.end(); i++)
     {
         (*i)(args...);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/tuple.h ns-3.40/src/core/model/tuple.h
--- ns-3.39/src/core/model/tuple.h	2023-07-05 14:23:47.765427000 -0700
+++ ns-3.40/src/core/model/tuple.h	2023-09-27 13:30:37.634839000 -0700
@@ -20,8 +20,8 @@
 #ifndef TUPLE_H
 #define TUPLE_H
 
-#include <ns3/attribute-helper.h>
-#include <ns3/string.h>
+#include "attribute-helper.h"
+#include "string.h"
 
 #include <algorithm>
 #include <sstream>
@@ -368,7 +368,7 @@
 
     bool Check(const AttributeValue& value) const override
     {
-        const TupleValue<Args...>* v = dynamic_cast<const TupleValue<Args...>*>(&value);
+        const auto v = dynamic_cast<const TupleValue<Args...>*>(&value);
         if (v == nullptr)
         {
             return false;
@@ -403,8 +403,8 @@
 
     bool Copy(const AttributeValue& source, AttributeValue& destination) const override
     {
-        const TupleValue<Args...>* src = dynamic_cast<const TupleValue<Args...>*>(&source);
-        TupleValue<Args...>* dst = dynamic_cast<TupleValue<Args...>*>(&destination);
+        const auto src = dynamic_cast<const TupleValue<Args...>*>(&source);
+        auto dst = dynamic_cast<TupleValue<Args...>*>(&destination);
         if (src == nullptr || dst == nullptr)
         {
             return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/type-id.cc ns-3.40/src/core/model/type-id.cc
--- ns-3.39/src/core/model/type-id.cc	2023-07-05 14:23:47.765427000 -0700
+++ ns-3.40/src/core/model/type-id.cc	2023-09-27 13:30:37.634839000 -0700
@@ -443,7 +443,7 @@
     m_information.push_back(information);
     std::size_t tuid = m_information.size();
     NS_ASSERT(tuid <= 0xffff);
-    uint16_t uid = static_cast<uint16_t>(tuid);
+    auto uid = static_cast<uint16_t>(tuid);
 
     // Add to both maps:
     m_namemap.insert(std::make_pair(name, uid));
@@ -512,7 +512,7 @@
 {
     NS_LOG_FUNCTION(IID << name);
     uint16_t uid = 0;
-    namemap_t::const_iterator it = m_namemap.find(name);
+    auto it = m_namemap.find(name);
     if (it != m_namemap.end())
     {
         uid = it->second;
@@ -525,7 +525,7 @@
 IidManager::GetUid(TypeId::hash_t hash) const
 {
     NS_LOG_FUNCTION(IID << hash);
-    hashmap_t::const_iterator it = m_hashmap.find(hash);
+    auto it = m_hashmap.find(hash);
     uint16_t uid = 0;
     if (it != m_hashmap.end())
     {
@@ -627,10 +627,7 @@
     IidInformation* information = LookupInformation(uid);
     while (true)
     {
-        for (std::vector<TypeId::AttributeInformation>::const_iterator i =
-                 information->attributes.begin();
-             i != information->attributes.end();
-             ++i)
+        for (auto i = information->attributes.begin(); i != information->attributes.end(); ++i)
         {
             if (i->name == name)
             {
@@ -729,10 +726,7 @@
     IidInformation* information = LookupInformation(uid);
     while (true)
     {
-        for (std::vector<TypeId::TraceSourceInformation>::const_iterator i =
-                 information->traceSources.begin();
-             i != information->traceSources.end();
-             ++i)
+        for (auto i = information->traceSources.begin(); i != information->traceSources.end(); ++i)
         {
             if (i->name == name)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/uinteger.cc ns-3.40/src/core/model/uinteger.cc
--- ns-3.39/src/core/model/uinteger.cc	2023-07-05 14:23:47.765427000 -0700
+++ ns-3.40/src/core/model/uinteger.cc	2023-09-27 13:30:37.634839000 -0700
@@ -65,7 +65,7 @@
         bool Check(const AttributeValue& value) const override
         {
             NS_LOG_FUNCTION(&value);
-            const UintegerValue* v = dynamic_cast<const UintegerValue*>(&value);
+            const auto v = dynamic_cast<const UintegerValue*>(&value);
             if (v == nullptr)
             {
                 return false;
@@ -102,8 +102,8 @@
         bool Copy(const AttributeValue& source, AttributeValue& destination) const override
         {
             NS_LOG_FUNCTION(&source << &destination);
-            const UintegerValue* src = dynamic_cast<const UintegerValue*>(&source);
-            UintegerValue* dst = dynamic_cast<UintegerValue*>(&destination);
+            const auto src = dynamic_cast<const UintegerValue*>(&source);
+            auto dst = dynamic_cast<UintegerValue*>(&destination);
             if (src == nullptr || dst == nullptr)
             {
                 return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/unused.h ns-3.40/src/core/model/unused.h
--- ns-3.39/src/core/model/unused.h	2023-07-05 14:23:47.765427000 -0700
+++ ns-3.40/src/core/model/unused.h	2023-09-27 13:30:37.634839000 -0700
@@ -20,7 +20,7 @@
 #ifndef UNUSED_H
 #define UNUSED_H
 
-#include "ns3/deprecated.h"
+#include "deprecated.h"
 
 /**
  * \file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/val-array.h ns-3.40/src/core/model/val-array.h
--- ns-3.39/src/core/model/val-array.h	2023-07-05 14:23:47.765427000 -0700
+++ ns-3.40/src/core/model/val-array.h	2023-09-27 13:30:37.634839000 -0700
@@ -19,8 +19,8 @@
 #ifndef VAL_ARRAY_H
 #define VAL_ARRAY_H
 
-#include <ns3/assert.h>
-#include <ns3/simple-ref-count.h>
+#include "assert.h"
+#include "simple-ref-count.h"
 
 #include <complex>
 #include <valarray>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/version.cache ns-3.40/src/core/model/version.cache
--- ns-3.39/src/core/model/version.cache	2023-07-05 14:24:26.185557800 -0700
+++ ns-3.40/src/core/model/version.cache	2023-09-27 13:31:04.826903800 -0700
@@ -1,10 +1,10 @@
-CLOSEST_TAG = '"ns-3.39"'
-VERSION_COMMIT_HASH = '"g10b9bc1af"'
+CLOSEST_TAG = '"ns-3.40"'
+VERSION_COMMIT_HASH = '"g4fdc985b5"'
 VERSION_DIRTY_FLAG = '0'
 VERSION_MAJOR = '3'
-VERSION_MINOR = '39'
+VERSION_MINOR = '40'
 VERSION_PATCH = '0'
 VERSION_RELEASE_CANDIDATE = '""'
-VERSION_TAG = '"ns-3.39"'
+VERSION_TAG = '"ns-3.40"'
 VERSION_TAG_DISTANCE = '0'
 VERSION_BUILD_PROFILE = 'default'
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/version.h ns-3.40/src/core/model/version.h
--- ns-3.39/src/core/model/version.h	2023-07-05 14:23:47.769427300 -0700
+++ ns-3.40/src/core/model/version.h	2023-09-27 13:30:37.634839000 -0700
@@ -20,7 +20,7 @@
 #ifndef BUILD_VERSION_H_
 #define BUILD_VERSION_H_
 
-#include "ns3/int64x64.h"
+#include "int64x64.h"
 
 #include <string>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/wall-clock-synchronizer.cc ns-3.40/src/core/model/wall-clock-synchronizer.cc
--- ns-3.39/src/core/model/wall-clock-synchronizer.cc	2023-07-05 14:23:47.769427300 -0700
+++ ns-3.40/src/core/model/wall-clock-synchronizer.cc	2023-09-27 13:30:37.634839000 -0700
@@ -363,7 +363,7 @@
     // have more drift than delay, then we just play catch up as fast as possible
     // by not delaying at all.
     //
-    uint64_t correction = (uint64_t)drift;
+    auto correction = (uint64_t)drift;
     if (correction <= nsDelay)
     {
         return nsDelay - correction;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/test/global-value-test-suite.cc ns-3.40/src/core/test/global-value-test-suite.cc
--- ns-3.39/src/core/test/global-value-test-suite.cc	2023-07-05 14:23:47.769427300 -0700
+++ ns-3.40/src/core/test/global-value-test-suite.cc	2023-09-27 13:30:37.634839000 -0700
@@ -84,7 +84,7 @@
     // Remove the global value for a valgrind clean run
     //
     GlobalValue::Vector* vector = GlobalValue::GetVector();
-    for (GlobalValue::Vector::iterator i = vector->begin(); i != vector->end(); ++i)
+    for (auto i = vector->begin(); i != vector->end(); ++i)
     {
         if ((*i) == &uint)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/test/int64x64-test-suite.cc ns-3.40/src/core/test/int64x64-test-suite.cc
--- ns-3.39/src/core/test/int64x64-test-suite.cc	2023-07-05 14:23:47.769427300 -0700
+++ ns-3.40/src/core/test/int64x64-test-suite.cc	2023-09-27 13:30:37.634839000 -0700
@@ -620,7 +620,7 @@
     std::cout << std::endl;
     std::cout << GetParent()->GetName() << " Bug 455: " << GetName() << std::endl;
 
-    int64x64_t a = int64x64_t(0.1);
+    int64x64_t a(0.1);
     a /= int64x64_t(1.25);
     Check(a.GetDouble(), 0.08, "The original testcase");
 
@@ -684,7 +684,7 @@
     std::cout << std::endl;
     std::cout << GetParent()->GetName() << " Bug 863: " << GetName() << std::endl;
 
-    int64x64_t a = int64x64_t(0.9);
+    int64x64_t a(0.9);
     a /= int64x64_t(1);
     Check(a.GetDouble(), 0.9, "The original testcase");
 
@@ -1033,7 +1033,7 @@
     const int64x64_t factorI = one / int64x64_t(factor);
 
     const int64x64_t a = int64x64_t::Invert(factor);
-    int64x64_t b = int64x64_t(factor);
+    int64x64_t b(factor);
 
     double tolerance = 0;
     if (int64x64_t::implementation == int64x64_t::ld_impl)
@@ -1045,15 +1045,15 @@
     b.MulByInvert(a);
     CheckCase(factor, b, one, "x * x^-1 == 1", tolerance);
 
-    int64x64_t c = int64x64_t(1);
+    int64x64_t c(1);
     c.MulByInvert(a);
     CheckCase(factor, c, factorI, "1 * x^-1 == 1 / x");
 
-    int64x64_t d = int64x64_t(1);
+    int64x64_t d(1);
     d /= (int64x64_t(factor));
     CheckCase(factor, d, c, "1/x == x^-1");
 
-    int64x64_t e = int64x64_t(-factor);
+    int64x64_t e(-factor);
     e.MulByInvert(a);
     CheckCase(factor, e, -one, "-x * x^-1 == -1", tolerance);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/test/ptr-test-suite.cc ns-3.40/src/core/test/ptr-test-suite.cc
--- ns-3.39/src/core/test/ptr-test-suite.cc	2023-07-05 14:23:47.769427300 -0700
+++ ns-3.40/src/core/test/ptr-test-suite.cc	2023-09-27 13:30:37.634839000 -0700
@@ -178,7 +178,7 @@
 void
 PtrTestCase::DoRun()
 {
-    m_nDestroyed = false;
+    m_nDestroyed = 0;
     {
         Ptr<NoCount> p = Create<NoCount>(this);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/csma/examples/csma-ping.cc ns-3.40/src/csma/examples/csma-ping.cc
--- ns-3.39/src/csma/examples/csma-ping.cc	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/csma/examples/csma-ping.cc	2023-09-27 13:30:37.638839000 -0700
@@ -100,7 +100,7 @@
 
     NS_LOG_INFO("Create Source");
     Config::SetDefault("ns3::Ipv4RawSocketImpl::Protocol", StringValue("2"));
-    InetSocketAddress dst = InetSocketAddress(addresses.GetAddress(3));
+    InetSocketAddress dst(addresses.GetAddress(3));
     OnOffHelper onoff = OnOffHelper("ns3::Ipv4RawSocketFactory", dst);
     onoff.SetConstantRate(DataRate(15000));
     onoff.SetAttribute("PacketSize", UintegerValue(1200));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/csma/examples/csma-raw-ip-socket.cc ns-3.40/src/csma/examples/csma-raw-ip-socket.cc
--- ns-3.39/src/csma/examples/csma-raw-ip-socket.cc	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/csma/examples/csma-raw-ip-socket.cc	2023-09-27 13:30:37.638839000 -0700
@@ -93,7 +93,7 @@
     NS_LOG_INFO("Create Source");
     // IP protocol configuration
     Config::SetDefault("ns3::Ipv4RawSocketImpl::Protocol", StringValue("2"));
-    InetSocketAddress dst = InetSocketAddress(addresses.GetAddress(3));
+    InetSocketAddress dst(addresses.GetAddress(3));
     OnOffHelper onoff = OnOffHelper("ns3::Ipv4RawSocketFactory", dst);
     onoff.SetConstantRate(DataRate(dataRate * 1000));
     onoff.SetAttribute("PacketSize", UintegerValue(1250));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/csma/helper/csma-helper.cc ns-3.40/src/csma/helper/csma-helper.cc
--- ns-3.39/src/csma/helper/csma-helper.cc	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/csma/helper/csma-helper.cc	2023-09-27 13:30:37.638839000 -0700
@@ -277,7 +277,7 @@
 {
     NetDeviceContainer devs;
 
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); i++)
+    for (auto i = c.Begin(); i != c.End(); i++)
     {
         devs.Add(InstallPriv(*i, channel));
     }
@@ -297,7 +297,7 @@
 {
     int64_t currentStream = stream;
     Ptr<NetDevice> netDevice;
-    for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         netDevice = (*i);
         Ptr<CsmaNetDevice> csma = DynamicCast<CsmaNetDevice>(netDevice);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/csma/model/backoff.cc ns-3.40/src/csma/model/backoff.cc
--- ns-3.39/src/csma/model/backoff.cc	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/csma/model/backoff.cc	2023-09-27 13:30:37.638839000 -0700
@@ -75,7 +75,7 @@
         maxSlot = m_maxSlots;
     }
 
-    uint32_t backoffSlots = (uint32_t)m_rng->GetValue(minSlot, maxSlot);
+    auto backoffSlots = (uint32_t)m_rng->GetValue(minSlot, maxSlot);
 
     Time backoff = Time(backoffSlots * m_slotTime);
     return backoff;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/csma/model/csma-channel.cc ns-3.40/src/csma/model/csma-channel.cc
--- ns-3.39/src/csma/model/csma-channel.cc	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/csma/model/csma-channel.cc	2023-09-27 13:30:37.638839000 -0700
@@ -86,8 +86,7 @@
     NS_LOG_FUNCTION(this << device);
     NS_ASSERT(device);
 
-    std::vector<CsmaDeviceRec>::iterator it;
-    for (it = m_deviceList.begin(); it < m_deviceList.end(); it++)
+    for (auto it = m_deviceList.begin(); it < m_deviceList.end(); it++)
     {
         if (it->devicePtr == device)
         {
@@ -161,8 +160,7 @@
     NS_LOG_FUNCTION(this << device);
     NS_ASSERT(device);
 
-    std::vector<CsmaDeviceRec>::iterator it;
-    for (it = m_deviceList.begin(); it < m_deviceList.end(); it++)
+    for (auto it = m_deviceList.begin(); it < m_deviceList.end(); it++)
     {
         if ((it->devicePtr == device) && (it->active))
         {
@@ -227,8 +225,7 @@
 
     NS_LOG_LOGIC("Receive");
 
-    std::vector<CsmaDeviceRec>::iterator it;
-    for (it = m_deviceList.begin(); it < m_deviceList.end(); it++)
+    for (auto it = m_deviceList.begin(); it < m_deviceList.end(); it++)
     {
         if (it->IsActive() && it->devicePtr != m_deviceList[m_currentSrc].devicePtr)
         {
@@ -261,8 +258,7 @@
 CsmaChannel::GetNumActDevices()
 {
     int numActDevices = 0;
-    std::vector<CsmaDeviceRec>::iterator it;
-    for (it = m_deviceList.begin(); it < m_deviceList.end(); it++)
+    for (auto it = m_deviceList.begin(); it < m_deviceList.end(); it++)
     {
         if (it->active)
         {
@@ -287,9 +283,8 @@
 int32_t
 CsmaChannel::GetDeviceNum(Ptr<CsmaNetDevice> device)
 {
-    std::vector<CsmaDeviceRec>::iterator it;
     int i = 0;
-    for (it = m_deviceList.begin(); it < m_deviceList.end(); it++)
+    for (auto it = m_deviceList.begin(); it < m_deviceList.end(); it++)
     {
         if (it->devicePtr == device)
         {
